#include <string.h>
#include <sys/indirect.h>
#include <sys/libwwc.h>
#include "lzil.h"


#define N   4096  /* obt@̑傫 */
#define F     18  /* Œv */


/*
 * get runtime DS using _TEXT, _DATA, CS
 * defined in c0ilib.obj
 */
extern unsigned il_get_ds();

/*
 * convert near pointer to CS based pointer
 * defined in c0ilib.obj
 */
extern void far *il_to_far(void near *nearpos);

extern LZIL lzIL;
static ILinfo lz_info;


/*---------------------------------------------------------------------*/
ILinfo far * far lz_get_info(){
    return (ILinfo far *)il_to_far(&lz_info);
}


/*---------------------------------------------------------------------*/
int far lz(void far *src, void far *dst, void far *work){

	unsigned char far	*pSrc = src;
	unsigned char far	*pDst = dst;
	unsigned char far	*pWork = work;
	short				i, j, k, r, c;
	unsigned short		flags;
	unsigned short		size;
	RES_LZ far			*pHeader = src;

	/* wb_̒ */

	/* FRLZ...DT  ǂ̃`FbN */
	if(	*(pSrc+0) != 'F' ||
		*(pSrc+1) != 'R' ||
		*(pSrc+2) != 'L' ||
		*(pSrc+3) != 'Z' ||
		*(pSrc+8) != 'D' ||
		*(pSrc+9) != 'T'    )
	{
		/* kt@Cł͂Ȃ */
		return 0;
	}

	size = pHeader->TYPE.DT.size;
	pSrc += sizeof(RES_COMMON_HEADER) + sizeof(TYPE_DT);

	/* [ÑNA */
	memset( pWork, 0, N-F );

	/* far pointer ̐K */
	pSrc = MK_FP(FP_SEG(pSrc) + (FP_OFF(pSrc) >> 4), FP_OFF(pSrc) & 0xf);
	pDst = MK_FP(FP_SEG(pDst) + (FP_OFF(pDst) >> 4), FP_OFF(pDst) & 0xf);

	r = N - F;
	flags = 0;

	for ( ; ; ) {

		if (((flags >>= 1) & 256) == 0) {

			if( size == 0 ){
				break;
			}

			c = *pSrc++;
			size--;
			flags = c | 0xff00;
		}

		if (flags & 1) {

			if( size == 0 ){
				break;
			}

			c = *pSrc++;
			size--;
			*pDst++ = c;
			pWork[r++] = c;
			r &= (N - 1);

		} else {

			if( size == 0 ){
				break;
			}

			i = *pSrc++;
			size--;

			if( size == 0 ){
				break;
			}

			j = *pSrc++;
			size--;
			i |= ((j & 0xf0) << 4);
			j = (j & 0x0f) + 2;

			for (k = 0; k <= j; k++) {
				c = pWork[(i + k) & (N - 1)];
				*pDst++ = c;
				pWork[r++] = c;
				r &= (N - 1);
			}

		}

	}

	return 1;

}

/*---------------------------------------------------------------------*/
unsigned short far lzFont(void far *src, void far *work, short spat){

	unsigned char far	*pSrc = src;
	unsigned char far	*pWork = work;
	int					i, j, k, r, c, idx=0;
	unsigned short		flags;
	unsigned short		size;
	unsigned short		sprites = 0;
	RES_LZ far			*pHeader = src;
	unsigned char		font_buf[32];

	/* wb_̒ */
	if(	*(pSrc+0) != 'F' ||
		*(pSrc+1) != 'R' ||
		*(pSrc+2) != 'L' ||
		*(pSrc+3) != 'Z' )
	{
		return 0;
	}

	if(	*(pSrc+8)=='D' && *(pSrc+9)=='T' ){

		/* DT  */
		size = pHeader->TYPE.DT.size;
		pSrc += sizeof(RES_COMMON_HEADER) + sizeof(TYPE_DT);	/* 12 */

	} else if( *(pSrc+8)=='B' && *(pSrc+9)=='M' ){

		/* BM  */
		size = pHeader->TYPE.BM.size;
		pSrc += sizeof(RES_COMMON_HEADER) + sizeof(TYPE_BM);	/* 52 */

	} else {

		return 0;

	}

	/* [ÑNA */
	memset( pWork, 0, N-F );

	/* far pointer ̐K */
	pSrc = MK_FP(FP_SEG(pSrc) + (FP_OFF(pSrc) >> 4), FP_OFF(pSrc) & 0xf);

	r = N - F;
	flags = 0;

	for ( ; ; ) {

		if (((flags >>= 1) & 256) == 0) {

			if( size == 0 ){
				break;
			}

			c = *pSrc++;
			size--;
			flags = c | 0xff00;

		}

		if (flags & 1) {

			if( size == 0 ){
				break;
			}

			c = *pSrc++;
			size--;

			font_buf[idx++] = c;
			idx &= 31;

			if(idx==0){
				/* ` */
				wwc_font_set_colordata( spat++, 1, (void far *)font_buf );
				sprites++;
			}

			pWork[r++] = c;
			r &= (N - 1);

		} else {

			if( size == 0 ){
				break;
			}

			i = *pSrc++;
			size--;

			if( size == 0 ){
				break;
			}

			j = *pSrc++;
			size--;
			i |= ((j & 0xf0) << 4);
			j = (j & 0x0f) + 2;

			for (k = 0; k <= j; k++) {

				c = pWork[(i + k) & (N - 1)];

				font_buf[idx++] = c;
				idx &= 31;

				if(idx==0){
					/* ` */
					wwc_font_set_colordata(spat++,1,(void far *)font_buf);
					sprites++;
				}

				pWork[r++] = c;
				r &= (N - 1);
			}

		}

	}

	return sprites;

}


/*---------------------------------------------------------------------*/
static ILinfo lz_info = {
    "LZ",
    "lz",
    "1.0",
    "LZIL version 1.0 by EXCEED.",
    (char far * far *)0,
};


